/*
								+----------------------------------+
								|                                  |
								|   ***  Expression parser  ***    |
								|                                  |
								|   Copyright   -tHE SWINe- 2006  |
								|                                  |
								|         GPU_ExpParser.h          |
								|                                  |
								+----------------------------------+
*/

#ifndef __EXPRESSION_PARSER_INCLUDED
#define __EXPRESSION_PARSER_INCLUDED

enum {
	token_Scalar,
	token_Vector,
	token_Matrix,
	token_Image,
	// variables (order is important, stronger type must have greater value)

	token_Number,
	// const number

	token_LeftPar,
	token_RightPar,
	token_Begin,
	token_End,
	token_Comma,
	token_Add,
	token_Sub,
	token_Mul,
	token_Div,
	// operators

	token_True,
	token_False,
	token_Square,
	token_Diamond,
	// constants words

	token_Blend,
	token_Decal,
	token_Invert,
	token_Abs,
	token_Min,
	token_Max,
	token_Thresh,
	token_Log,
	token_Exp,
	token_Sqrt,
	token_Pow,
	token_Scale,
	token_CMatrix,
	token_Grey,
	token_Resize,
	token_Rotate,
	token_Lerp,
	token_Erode,
	token_Dilate,
	token_Open,
	token_Close,
	token_HitMiss,
	token_Mean,
	token_Median,
	token_Convolve,
	// function names

	token_EndOfLine
	// end of string
};

/**
 *	struct TToken
 *		- token structure
 */
typedef struct TToken {
	int n_string_pos;
	int n_type;
	union {
		int n_id;
		float f_value;
	} t_data;
} TToken;

const char *p_s_Emit_Ident(TToken *p_token, const char *p_s_buffer);
const char *p_s_Emit_Matrix(TToken *p_token, const char *p_s_buffer);
const char *p_s_Emit_Scalar(TToken *p_token, const char *p_s_buffer);
const char *p_s_Emit_Constant(TToken *p_token, const char *p_s_buffer);
const char *p_s_Emit_Operator(TToken *p_token, const char *p_s_buffer);
const char *p_s_Emit_Keyword(TToken *p_token, const char *p_s_buffer);

#endif //__EXPRESSION_PARSER_INCLUDED
